=== debian/changelog ===
chiaki (2.2.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112776)
  * Re-add Recommends: libqt5multimedia5-plugins (Closes: #1061325)

 -- Adrian Bunk <bunk@debian.org>  Sat, 18 Oct 2025 20:12:01 +0300

chiaki (2.2.0-1) unstable; urgency=medium

  * The Akamai Technologies paid volunteer days release.
  * New upstream version. 
  * Updated build dependencies.
  * Bumped Standards-Version to 4.6.2 (no changes needed).

 -- Bartosz Fenski <fenio@debian.org>  Tue, 19 Dec 2023 15:54:39 +0100
