=== debian/control ===
Source: chiaki
Section: utils
Priority: optional
Maintainer: Bartosz Fenski <fenio@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libopus-dev, qtmultimedia5-dev, libqt5svg5-dev, libsdl2-dev, libavcodec-dev, libswscale-dev, libjerasure-dev, libnanopb-dev, libssl-dev, protobuf-compiler, python3-protobuf, libevdev-dev, libudev-dev, libqt5opengl5-dev, python3-dev, libgl-dev, imagemagick, librsvg2-bin, libpthread-stubs0-dev, libpthreadpool-dev, nanopb
Standards-Version: 4.6.2
Homepage: https://git.sr.ht/~thestr4ng3r/chiaki
Rules-Requires-Root: no

Package: chiaki
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libqt5multimedia5-plugins
Description: PlayStation remote play client
 Chiaki is an unofficial, free and open source PlayStation Remote Play Client.
 While not an official Sony software, Chiaki doesn't require having a jailbroken 
 console.
 .
 Everything necessary for a full streaming session, including the initial 
 registration and wakeup of the console, is supported.
