=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://git.sr.ht/~thestr4ng3r/chiaki/refs \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
